From 6de3de924d3810a19474d5a78afa20e59bca4ef9 Mon Sep 17 00:00:00 2001
From: Manuel <maaanuuu@gmx.net>
Date: Fri, 21 Mar 2008 13:03:16 +0100
Subject: [PATCH] probably fix hpel_filter_altivec

---
 common/ppc/mc.c |   31 ++++++++++++++++++++++++++++++-
 1 files changed, 30 insertions(+), 1 deletions(-)

diff --git a/common/ppc/mc.c b/common/ppc/mc.c
index eff4360..76d3161 100644
--- a/common/ppc/mc.c
+++ b/common/ppc/mc.c
@@ -611,11 +611,40 @@ void x264_hpel_filter_altivec( uint8_t *dsth, uint8_t *dstv, uint8_t *dstc, uint
             HPEL_FILTER_CENTRAL();
         }
 
+        /* Partial vertical filter */
+        VEC_LOAD( &src[x+i_stride*(y-2)], src1v, 16, vec_u8_t );
+        VEC_LOAD( &src[x+i_stride*(y-1)], src2v, 16, vec_u8_t );
+        VEC_LOAD( &src[x+i_stride*(y-0)], src3v, 16, vec_u8_t );
+        VEC_LOAD( &src[x+i_stride*(y+1)], src4v, 16, vec_u8_t );
+        VEC_LOAD( &src[x+i_stride*(y+2)], src5v, 16, vec_u8_t );
+        VEC_LOAD( &src[x+i_stride*(y+3)], src6v, 16, vec_u8_t );
+
+        temp1v = vec_u8_to_s16_h( src1v );
+        temp2v = vec_u8_to_s16_h( src2v );
+        temp3v = vec_u8_to_s16_h( src3v );
+        temp4v = vec_u8_to_s16_h( src4v );
+        temp5v = vec_u8_to_s16_h( src5v );
+        temp6v = vec_u8_to_s16_h( src6v );
+
+        HPEL_FILTER_1( temp1v, temp2v, temp3v,
+                      temp4v, temp5v, temp6v );
+
+        temp4v = vec_u8_to_s16_l( src1v );
+        temp5v = vec_u8_to_s16_l( src2v );
+        temp6v = vec_u8_to_s16_l( src3v );
+        temp7v = vec_u8_to_s16_l( src4v );
+        temp8v = vec_u8_to_s16_l( src5v );
+        temp9v = vec_u8_to_s16_l( src6v );
+
+        HPEL_FILTER_1( temp4v, temp5v, temp6v,
+                      temp7v, temp8v, temp9v );
+
         /* central_filter */
         tempav = tempcv;
         tempbv = tempdv;
         tempcv = tempev;
-        tempdv = vec_splat( tempcv, 7 ); /* last only */
+        tempdv = temp1v;
+        tempev = temp4v;
 
         HPEL_FILTER_CENTRAL();
     }
-- 
1.5.4.3

